//Zielscheiben zufllig aufklappen   [Vienna 26.01.2012  Arma2]
//
// !!! "Zielscheibe(klein)" verwenden !!!
//
// Aufruf in Auslser: temp = [[Scheibe1, Scheibe2,...],20] execVM "ZielScheiben.sqf"
//  die 20 steht fr die Wiederhloungen.

private ["_zielscheiben","_wiederholen","_i","_treffer","_anzahl","_scheibe","_zeit","_alt"]; 

_zielscheiben = _this select 0;
_wiederholen  = _this select 1;

_treffer = 0;
_anzahl  = count _zielscheiben;

//alle Scheiben umlegen
titleText ["Warten auf Feuerbefehl!","plain"];
{_x animate["terc",1]} forEach _zielscheiben;
sleep 3;
titleText ["\n\n\nFeuer frei!","plain"];

//Runden starten
for "_i" from 1 to _wiederholen do 
 {
  //Erste Scheibe auswhlen
  if(_i==1)then{_scheibe=_zielscheiben select(floor(random _anzahl))};
  //Scheibe aufrichten
  _scheibe animate["terc", 0];
  //Maximale Zeit zum Schieen (minimum 4 Sekunden)
  _zeit = time + 6;
  sleep 4; //Mindestwarten bis Scheibe steht bzw. die vorherige umgelegt wird
  //Trefferabfrage
  waituntil {time > _zeit or _scheibe animationPhase "terc" > 0.2};
  if (_scheibe animationPhase "terc" > 0.2) then
   {
    _treffer = _treffer+1
   };
  //Trefferanzeige Zwischenergebnis
  hint format ["\nZiele: %1\n\nGetroffen: %2",_i,_treffer];
  //Scheibe in _alt speichern
  _alt = _scheibe;
  //Unterroutine welche die Scheibe jetzt 3 Sekunden lang umlegt
  _alt spawn 
    {
      private "_r";
      for "_r" from 1 to 30 do 
       {
        _this animate["terc", 1]; //Scheibe umlegen
        sleep 0.1
       }
    };
  //Weitere Scheibe (darf nicht die vorherige sein)
  while {_scheibe==_alt}do{_scheibe=_zielscheiben select(floor(random _anzahl))};
  //Treffer Endergebnis anzeigen
  if (_i==_wiederholen) then {titleText [format ["%1 Ziele. Davon %2 getroffen.",_i,_treffer],"plain"]};
 };



/* Erklrung zu Random

random 3 gibt einen Dezimalwert von 0 - 2,9999 zurck.

ceil rundet alles auf eine Ganzzahl auf.

ceil (random 3) ergibt 1, 2 oder 3.

floor schneidet alle Nachkommastellen ab.

floor (random 3) ergibt 0, 1 oder 2 (ideal fr Array Index).

Der Index eines Arrays beginnt bei 0. Verwendet man dafr ceil, dann erfordert das fr den Array Index -1 anzufgen.

round (random 3) ergibt 0, 1, 2 oder 3. 
Fr ein Array mit 3 Feldern wrden das zu Fehlern fhren. Auch ist die Zufallsverteilung nicht korrekt:

0 = 0,00 - 0,49
1 = 0,50 - 1,49
2 = 1,50 - 2,49
3 = 2,50 - 2,99

ceil und floor ergeben ein ausgewogenes Zufallsverhltnis.

Edit: Verwendet man fr den Array-Index ArrayName select random 3, dann rundet select und es kommt zum round - Fehler. 